/* HEXDUMP utility
 */

#include <common.h>
#include "global.h"

#define	BUFSIZE	16

unsigned char buf[BUFSIZE];

char *hexchars = "0123456789abcdef";

void
puthexbyte(char *p, unsigned char b)
{
	*p = hexchars[(b >> 4) & 0x0f];
	p++;
	*p = hexchars[b & 0x0f];
}

void
puthexshort(char *p, unsigned short s)
{
	puthexbyte(p, (s >> 8) & 0xff);
	puthexbyte(p + 2, s & 0xff);
}

void
hexdump(char *label,unsigned char *buf,int offset, int len)
{
	int qty,i;
	unsigned char *p;
	char *out,dumpline[100];

	while (len > 0) {
		strcpy(dumpline,label);
		out = dumpline + strlen(label);
		qty = len;
		if (qty > 16)
			qty = 16;
		puthexshort(out,offset);
		out += 4;
		*out++ = ' ';
		*out++ = ' ';
		offset += qty;
		p = buf;
		for(i=qty ; i>0 ; i--) {
			puthexbyte(out,*p++);
			out += 2;
			*out++ = ' ';
		}
		for(i=qty ; i<16 ; i++) {
			*out++ = ' ';
			*out++ = ' ';
			*out++ = ' ';
		}
		*out++ = ' ';
		*out++ = '|';
		p = buf;
		for(i=qty ; i>0 ; i--) {
			if (*p > 0x1f && *p < 0x7f)
				*out++ = *p;
			else
				*out++ = '.';
			p++;
		}
		for(i=qty ; i<16 ; i++) {
				*out++ = ' ';
		}
		len -= qty;
		buf += qty;
		*out++ = '|';
		*out++ = '\n';
		*out = '\0';
/*
		write(1,dumpline,strlen(dumpline));
*/		printf(dumpline);
		out = dumpline;
	}
}

