/*
 * Basic command interpreter
 */

#include <common.h>
#include "global.h"
#include "cmdparse.h"

static char *Prompt = "PortTest> ";
static int go_on;

int doexit __ARGS((int argc,char *argv[],void *p));
int dohelp __ARGS((int argc,char *argv[],void *p));

int dobootsec __ARGS((int argc,char *argv[],void *p));
int dorootdir __ARGS((int argc,char *argv[],void *p));
int dodisplay __ARGS((int argc,char *argv[],void *p));
int domonitor __ARGS((int argc,char *argv[],void *p));

/* Command lookup and branch tables */
struct cmds Cmds[] = {
	{"display",	dodisplay, 0,	"Display ports",	NULLCHAR},
	{"exit",	doexit,	0,	"Exit program",	NULLCHAR},
	{"help",	dohelp,	0,	"Print help",	NULLCHAR},
	{"monitor",	domonitor,0,	"Monitor port changes",	NULLCHAR},
	{"?",		dohelp,	0,	"Print help",	NULLCHAR},
	{NULLCHAR,	NULLFP, 0,	NULLCHAR,
				"Unknown command; type \"?\" for list"}
};

int
main(int argc, char *argv[])
{
	char	inbuf[256];

        /* Print the ABI version */
        app_startup(argv);

	/* Init portcmds globals */
	init_globals();

	/* Read commands from keyboard */
	go_on = 1;
	while(go_on) {
		printf(Prompt);
		gets(inbuf,256);
		rip(inbuf);
		if (strlen(inbuf) > 0)
			cmdparse(Cmds,inbuf,NULL);
	}
	return 0;
}

int
donop(int argc, char *argv[], void *p)
{
	return(0);
}
  
int
doexit(int argc, char *argv[], void *p)
{
	go_on = 0;
	return 0;
}
  
int
dohelp(int argc, char *argv[], void *p)
{
	register struct cmds *cmdp;
  
	puts("Main commands:\n");
        for(cmdp = Cmds;cmdp->name != NULL;cmdp++){
		printf("%-12s: %s\n",cmdp->name,cmdp->helpmsg);
        }
	return 0;
}
 
