/* Port Commands
 */
#include <common.h>

/* Port masks: mask of known bits */
/* PORTA:
 * PA04	CLK4		0x0800
 * PA06	CLK2		0x0200
 * PA12	TXD2		0x0008
 * PA13	RXD2		0x0004
 */
#define	MSK_PORTA	0x0a0c

/* PORTB:
 * PB16	????		0x8000
 * PB24	SMRXD1		0x0080
 * PB25	SMTXD1		0x0040
 */
#define	MSK_PORTB	0x00c0

/* PORTC:
 * bit ?
 */
#define	MSK_PORTC	0x0008

/* PORTD:
 * bit ?
 */
#define	MSK_PORTD	0x0000

unsigned short porta, portb, portc, portd;

void
init_globals(void)
{
	porta = *(unsigned short *)0xff000956;
	porta &= ~MSK_PORTA;
	portb = *(unsigned short *)0xff000ac6;
	portb &= ~MSK_PORTB;
	portc = *(unsigned short *)0xff000966;
	portc &= ~MSK_PORTC;
	portd = *(unsigned short *)0xff000976;
	portd &= ~MSK_PORTD;
}

/* Display actual port settings */
int
dodisplay(int argc, char *argv[], void *p)
{
	printf("PAODR:	0x%04x	PADAT:	0x%04x	PADIR:	0x%04x	PAPAR:	0x%04x\n",
		*(unsigned short *)0xff000954,
		*(unsigned short *)0xff000956,
		*(unsigned short *)0xff000950,
		*(unsigned short *)0xff000952);
		
	/* Port B upper word omitted ! */
	printf("PBODR:	0x%04x	PBDAT:	0x%04x	PBDIR:	0x%04x	PBPAR:	0x%04x\n",
		*(unsigned short *)0xff000ac2,
		*(unsigned short *)0xff000ac6,
		*(unsigned short *)0xff000aba,
		*(unsigned short *)0xff000abe);
		
	printf("PCDAT:	0x%04x	PCDIR:	0x%04x	PCPAR:	0x%04x	PCSO:	0x%04x	PCINT;	0x%04x\n",
		*(unsigned short *)0xff000966,
		*(unsigned short *)0xff000960,
		*(unsigned short *)0xff000962,
		*(unsigned short *)0xff000964,
		*(unsigned short *)0xff000968);
		
	printf("PDDAT:	0x%04x	PDDIR:	0x%04x	PDPAR:	0x%04x\n",
		*(unsigned short *)0xff000976,
		*(unsigned short *)0xff000970,
		*(unsigned short *)0xff000972);
		
	printf("\n");
	printf("PADAT:	0x%04x	PBDAT:	0x%04x	PCDAT:	0x%04x	PDDAT:	0x%04x\n",
		*(unsigned short *)0xff000956,
		*(unsigned short *)0xff000ac6,
		*(unsigned short *)0xff000966,
		*(unsigned short *)0xff000976);

	return(0);
}

/* Monitor ports */
int
domonitor(int argc, char *argv[], void *p)
{
	unsigned short lporta, lportb, lportc, lportd;

	init_globals();
	while(! tstc()) {
		lporta = *(unsigned short *)0xff000956;
		lporta &= ~MSK_PORTA;
		lportb = *(unsigned short *)0xff000ac6;
		lportb &= ~MSK_PORTB;
		lportc = *(unsigned short *)0xff000966;
		lportc &= ~MSK_PORTC;
		lportd = *(unsigned short *)0xff000976;
		lportd &= ~MSK_PORTD;
		if (lporta != porta) {
			printf("\nPA: 0x%04x -> 0x%04x : 0x%04x\n",
				porta,lporta,porta ^ lporta);
			putc('\007');getc();
		}
		if (lportb != portb) {
			printf("\nPB: 0x%04x -> 0x%04x : 0x%04x\n",
				portb,lportb,portb ^ lportb);
			putc('\007');getc();
		}
		if (lportc != portc) {
			printf("\nPC: 0x%04x -> 0x%04x : 0x%04x\n",
				portc,lportc,portc ^ lportc);
			putc('\007');getc();
		}
		if (lportd != portd) {
			printf("\nPD: 0x%04x -> 0x%04x : 0x%04x\n",
				portd,lportd,portd ^ lportd);
			putc('\007');getc();
		}
		udelay(100000);putc('.');
	}
	getc();
	putc('\n');

	return(0);
}
